import { Collection, Schema, FindOneOptions, FindOptions, Selector } from "./MeteorCollectionTypings";
export default abstract class MeteorCollection {
    private static _$collection;
    private static _$schema?;
    static $collection: Collection<any>;
    static $schema: Schema | null | undefined;
    private static attachSchema();
    static findOne<T extends MeteorCollection>(this: typeof MeteorCollection & (new (arg: any, ...args: any[]) => T), selector?: Selector, options?: FindOneOptions): T;
    static find(selector?: Selector, options?: FindOptions): Mongo.Cursor<any>;
    static fetch<T extends MeteorCollection>(this: typeof MeteorCollection & (new (arg: any, ...args: any[]) => T), cursor: any): any;
    static remove(selector: Selector): void;
    static insert(doc: object): void;
    static upsert(selector: Selector, values: object, multi: boolean): void;
    static update(selector: Selector, values: object, multi: boolean): void;
    static replace(selector: Selector, values: object, multi: boolean): void;
}
