Object.defineProperty(exports, "__esModule", { value: true });
var pluralize = require("pluralize");
var MeteorCollection = (function () {
    function MeteorCollection() {
    }
    Object.defineProperty(MeteorCollection, "$collection", {
        get: function () {
            if (!this._$collection) {
                var Class = this.constructor;
                var collectionName = pluralize.plural(this.name);
                this._$collection = new Mongo.Collection(collectionName);
            }
            return this._$collection;
        },
        set: function (collection) {
            this._$collection = collection;
            this.attachSchema();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MeteorCollection, "$schema", {
        get: function () {
            return this._$schema;
        },
        set: function (schema) {
            this._$schema = schema;
            this.attachSchema();
        },
        enumerable: true,
        configurable: true
    });
    MeteorCollection.attachSchema = function () {
        if (this.$collection && this.$schema && this.$collection.attachSchema) {
            try {
                this.$collection.attachSchema(this.$schema);
            }
            catch (err) { }
        }
    };
    MeteorCollection.findOne = function (selector, options) {
        if (selector === void 0) { selector = {}; }
        if (options === void 0) { options = {}; }
        var item = this.$collection.findOne(selector, options);
        return new this(item);
    };
    MeteorCollection.find = function (selector, options) {
        if (selector === void 0) { selector = {}; }
        if (options === void 0) { options = {}; }
        return this.$collection.find(selector, options);
    };
    MeteorCollection.fetch = function (cursor) {
        var _this = this;
        return cursor.map(function (item) { return new _this(item); });
    };
    MeteorCollection.remove = function (selector) {
        this.$collection.remove(selector);
    };
    MeteorCollection.insert = function (doc) {
        this.$collection.insert(doc);
    };
    MeteorCollection.upsert = function (selector, values, multi) {
        this.$collection.upsert(selector, { $set: values });
    };
    MeteorCollection.update = function (selector, values, multi) {
        this.$collection.update(selector, { $set: values }, { multi: multi });
    };
    MeteorCollection.replace = function (selector, values, multi) {
        this.$collection.update(selector, values, { multi: multi });
    };
    return MeteorCollection;
}());
exports.default = MeteorCollection;
