var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var MeteorMethodClasses = {};
function Persistable(middleware) {
    var decoratorName = arguments.callee.name;
    return function (ClassConstructor) {
        var classIdentifier = generateIdentifier(ClassConstructor);
        MeteorMethodClasses[classIdentifier] = ClassConstructor;
        validateMiddlewareArgument(middleware, decoratorName, classIdentifier);
        transformToMeteorMethod(ClassConstructor.prototype.save, middleware, ClassConstructor, "save");
        transformToMeteorMethod(ClassConstructor.prototype.delete, middleware, ClassConstructor, "delete");
    };
}
exports.Persistable = Persistable;
function PubSub(middleware) {
    var decoratorName = arguments.callee.name;
    return function (target, key, descriptor) {
        var publicationIdentifier = generateIdentifier(target, key);
        validateMiddlewareArgument(middleware, decoratorName, publicationIdentifier);
        if (Meteor.isServer) {
            Meteor.publish(publicationIdentifier, function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                runMiddleware.apply(void 0, [middleware, decoratorName, publicationIdentifier].concat(args));
                return descriptor.value.apply(descriptor, args);
            });
        }
        else {
            descriptor.value = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        return [2, new Promise(function (resolve, reject) {
                                Meteor.subscribe.apply(Meteor, [publicationIdentifier].concat(args, [{
                                        onReady: function () { return resolve(); },
                                        onStop: function (error) { return reject(error); }
                                    }]));
                            })];
                    });
                });
            };
        }
    };
}
exports.PubSub = PubSub;
function MeteorMethod(middleware) {
    var decoratorName = arguments.callee.name;
    return function (target, key, descriptor) {
        var methodIdentifier = generateIdentifier(target.constructor, key);
        validateMiddlewareArgument(middleware, decoratorName, methodIdentifier);
        transformToMeteorMethod(descriptor.value, middleware, target, key);
    };
}
exports.MeteorMethod = MeteorMethod;
function ServerOnly(target, key, descriptor) {
    var method = descriptor.value;
    var methodIdentifier = generateIdentifier(target.constructor, key);
    descriptor.value = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!Meteor.isServer) {
            throw Error("Method " + methodIdentifier + " can only be run on the server");
        }
        method.apply.apply(method, [this].concat(args));
    };
}
exports.ServerOnly = ServerOnly;
function ClientOnly(target, key, descriptor) {
    var method = descriptor.value;
    var methodIdentifier = generateIdentifier(target.constructor, key);
    descriptor.value = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (Meteor.isServer) {
            throw Error("Method " + methodIdentifier + " can only be run on the client");
        }
        method.apply.apply(method, [this].concat(args));
    };
}
exports.ClientOnly = ClientOnly;
function generateIdentifier(ClassConstructor, methodName, prefix) {
    var name = prefix ? prefix + '.' : '';
    name += ClassConstructor.name;
    while ((ClassConstructor = Object.getPrototypeOf(ClassConstructor)) != Function.prototype && ClassConstructor) {
        name = ClassConstructor.name + "." + name;
    }
    if (methodName)
        name = name + "." + methodName;
    return name;
}
function transformToMeteorMethod(serverMethod, middleware, affectedClass, methodName) {
    var methodIdentifier = generateIdentifier(affectedClass, methodName);
    var classIdentifier = generateIdentifier(affectedClass);
    MeteorMethodClasses[classIdentifier] = affectedClass;
    if (Meteor.isServer) {
        Meteor.methods((_a = {},
            _a[methodIdentifier] = function (modelProps) {
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                runMiddleware.apply(void 0, [middleware, "MeteorMethod", methodIdentifier].concat(args));
                var model = new MeteorMethodClasses[classIdentifier](modelProps);
                serverMethod.apply.apply(serverMethod, [model].concat(args));
            },
            _a));
    }
    else {
        affectedClass.prototype[methodName] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    return [2, new Promise(function (resolve, reject) {
                            Meteor.call.apply(Meteor, [methodIdentifier, _this].concat(args, [function (error, result) {
                                    if (error)
                                        reject(error);
                                    resolve(result);
                                }]));
                        })];
                });
            });
        };
    }
    var _a;
}
function validateMiddlewareArgument(middleware, decoratorName, targetIdentifier) {
    var isValidMiddleware = middleware === null || middleware instanceof Function || middleware instanceof Array;
    if (middleware === undefined) {
        throw Error("No middleware specified for @" + decoratorName + " decorator on " + targetIdentifier + ". \n            This is a potential security risk. Please pass a middleware function as a decorator argument or\n            null if you are sure that you want to expose the save and delete methods without middleware.");
    }
    if (!isValidMiddleware) {
        throw Error("Invalid middleware defined for @" + decoratorName + " decorator on " + targetIdentifier);
    }
}
function runMiddleware(middleware, decoratorName, callerName) {
    var args = [];
    for (var _i = 3; _i < arguments.length; _i++) {
        args[_i - 3] = arguments[_i];
    }
    if (middleware === undefined) {
        throw Error("No middleware specified for " + decoratorName + " decorator on " + callerName + ". \n            This is a potential security risk. Please pass a middleware function as a decorator argument or\n            null if you are sure that you want to expose the method without middleware.");
    }
    if (middleware instanceof Array) {
        middleware.forEach(function (middleware) { return middleware.apply(void 0, args); });
    }
    else if (middleware instanceof Function) {
        middleware.apply(void 0, args);
    }
    else if (middleware !== null) {
        throw Error("Invalid middleware defined for " + decoratorName + " decorator on " + callerName + ".");
    }
}
